/***************************************************************************

       File: sectionio.h
   Contents: Header file for sectionio.c
Exported by: sectionio.c
Imported by: runio.c, init.c, xmtutor.c
    Part of: The Xmtutor application
     Author: Jan Borchers (job@ira.uka.de)

    $Source: /home/mit1/job/distribution/Xmtut/RCS/sectionio.h,v $
  $Revision: 1.3 $
      $Date: 1994/10/17 18:14:35 $
     $State: Rel $
    $Locker:  $

$Log: sectionio.h,v $
 * Revision 1.3  1994/10/17  18:14:35  job
 * First revision under version control.
 *

***************************************************************************/


/**************************************************************************/
/*                                                                        */
/* COPYRIGHT NOTICE:                                                      */
/* -----------------                                                      */
/* All parts of the Xmtutor application and the sample Motif tutorial are */
/* Copyright (C) 1993,1994 Jan Borchers.                                  */
/*                                                                        */
/**************************************************************************/


EXTERN Cardinal numberOfChapters;				/* Number of chapters available, filled from resource file */
EXTERN Cardinal currentChapter;					/* Number of the current chapter */
EXTERN Cardinal currentSection;					/* Number of the current section */
								/* (relative to chapterInfo[currentChapter].sectionOffset!) */
EXTERN Cardinal numberOfIndexEntries;				/* Number of entries in the index */

struct chapterInfoType						/* Structure to keep information on chapters */
{
  String    title;						/* Title of chapter, eg "Display Widgets" */
  String    directory;						/* Directory name of chapter, eg "DisplayWidgets/" */
  Cardinal  numberOfSections;					/* Number of sections in this chapter */
  Cardinal  sectionOffset;					/* Computed Index offset of first section in this chapter */
};
EXTERN struct chapterInfoType chapterInfo [30];			/* Storage for chapters, filled from resource file */

struct sectionInfoType						/* Structure to keep information on chapter subsections */
{
  String title;							/* Title of section, eg "The Label Widget" */
  String filename;						/* Filename of section, eg "label" */
  Boolean hasProgram;						/* TRUE if section has example program & resource files */
};
EXTERN struct sectionInfoType sectionInfo [200];		/* Storage for sections, filled from resource file */

struct indexEntryType
{
  String    keyword;
  Cardinal  chapter,section;
};
EXTERN struct indexEntryType indexEntries [1000];		/* Storage for index entries, filled from index file */


/* Chapter I/O routine declarations */

EXTERN void GetXmtutorResources (Widget toplevel);		/* Gets application resources for Xmtutor, especially */
								/* chapter & section information */

EXTERN String ExecName (void);					/* Construct filename for executable program file, e.g. */
								/* "XMTUTOR_CONTENTSPATH/ASimpleExample/hello" */
								/* This routine is needed by runio.c */

EXTERN String UserResourceName (void);				/* Construct filename for user's resourcefile, e.g. */
								/* "XMTUTOR_USERRESOURCEPATH/Pushbutton" */
								/* This routine is needed by runio.c */

EXTERN void ReadIndexFile (void);				/* Reads the index file */
EXTERN void ReadSection (void);					/* Reads a section */
EXTERN void SaveResource (void);				/* Saves example resource before executing */
EXTERN void RestoreResource (void);				/* Restores original version of a resource file */
